using System.Reflection;

namespace DumpExtensionExample
{
    static class Program
    {
        class Client
        {
            public string? Name { get; set; }
            public int? Age { get; set; }
        }

        public static void Main(string[] args)
        {
            Client client1 = new();
            Client client2 = new();

            client1.Name = "Omar";
            client2.Age = 23;
            CopyNullFields(from: client2, to: client1);
        }

        static void CopyNullFields(object from, object to)
        {
            Type fromType = from.GetType();
            Type toType = to.GetType();
            if (fromType != toType)
                return;
            PropertyInfo[] fromProperties = fromType.GetProperties();
            foreach (PropertyInfo property in fromProperties)
            {
                object? toValue = property.GetValue(to);

                if (toValue == null) {
                    object? fromValue = property.GetValue(from);
                    property.SetValue(to, fromValue);
                }
            }
        }
    }
}
